<?php

require_once('php/lib/configured_object.php');

config('Template', 'template');

/**
 * Abstract template.
 *
 * The template is responsible for creating the appropriate output.
 *
 * @abstract
 * @author Pascal de Vink
 */
class Template extends ConfiguredObject {

	/**
	 * Renders template contents
	 *
	 * @access public
	 */
	function render() {
		trigger_error(sprintf('%s() not implemented', 'render'), E_USER_ERROR);
	}
	
	/**
	 * Returns template contents
	 *
	 * @access public
	 */
	function content() {
		ob_start();
		$this->render();
		$contents = ob_get_contents();
		ob_end_clean();
		return $contents;
	}
}
?>