<?php
require_once('php/lib/mvc/view.php');

/**
 * PHP view for files.
 *
 * @author Pascal de Vink
 */
class PhpView extends View {
	
	/**
	 * URL to file (private so it doesn't get registered with php)
	 *
	 * @var string
	 * @access private
	 */
	var $_url;
	
	/**
	 * Constructs new instance.
	 *
	 * @param string $url URL for file
	 * @access public
	 */
	function __construct($url) {
		parent::__construct();
		$this->_url = $url;
	}

	/**
	 * @see View::render()
	 */
	function render() {
		
		# register all view variables as 'globals' for PHP file
		foreach (array_keys(get_object_vars($this)) as $var) {
			if (substr($var, 0, 1) == '_') continue;
			$$var =& $this->$var;
		}
		
		# read file
		include($this->_url);
	}
}
?>